# POST /documentprocessing/document/append

> Combine Base64 documents into one with AppendBody: separate them by nothing, a new paragraph or a new section, set DocumentSettings and choose the returnFormat.

- **Product:** DS Server
- **Section:** Documentation
- **Kind:** Endpoint
- **Path:** DS Server > API Reference > Web API > DocumentProcessing > /document/append > POST /documentprocessing/document/append
- **1541 words**
- **Web URL:** https://docs.textcontrol.com/ds-server/reference/web-api/documentprocessing/document-append/post/
- **LLMs URL:** https://docs.textcontrol.com/ds-server/reference/web-api/documentprocessing/document-append/post/llms.txt
- **LLMs-Full URL:** https://docs.textcontrol.com/ds-server/reference/web-api/documentprocessing/document-append/post/llms-full.txt

---

`POST` `https://example.com/documentprocessing/document/append`

### Description

Combines documents by appending them divided by a new section, paragraph or nothing.

### Examples

The following example appends two documents to create one PDF document.

```bash
# Request:
curl --location --request POST 'https://trial.dsserver.io/documentprocessing/document/append?returnFormat=PDF' \
    --header 'Content-Type: application/json' \
    --header 'Authorization: Bearer GphAd1R0npJM9OuX2y9mUa4cfqPMOg6p' \
    --data-raw '{
        "documents":[
            {
                "document": "UEsDBBQAAAAIAAACAAC5EQAA[..]="
            },
            {
                "document": "JVBERi0xLjQKMSAwIG9iago8[..]",
                "documentDivider": 1
            }
        ]
    }'

# Result:
"JVBERi0xLjQNJeLjz9MNMSAwIG9iago8PAovVH[..]"
```

### Authorization

This endpoint supports the OAuth authorization method. DS Server checks the access token only when OAuth is enabled in the admin portal (see [Enable OAuth](https://docs.textcontrol.com/ds-server/administration/oauth/llms-full.txt)). With OAuth disabled, the default of a new installation, the endpoint accepts requests without a token.

DS Server implements OAuth as the authorization method. Two flows are supported:

- Authorization Code
- Client Credentials

To use the *Client Credentials* flow, switch on **Allow “Client Credentials” grant type** in the security profile (see [OAuth Grant Types](https://docs.textcontrol.com/ds-server/administration/oauth-grant-types/llms-full.txt)).

In both cases, a valid access token returned from the OAuth endpoints must be passed in a *Bearer* **Authorization Header**, as a **Query Parameter** or in a **Cookie**.

#### Authorization Header

| Header field | Description |
|---|---|
| Authorization | A Bearer authorization header (also called token authentication) contains the OAuth access token. The authorization method and a space i.e. "Bearer " is then put before your valid access token. For example: `Authorization: Bearer 4796E23054E64BC773CACBCAF24AD179DE9A3` |

#### Query Parameter

| Query parameter | Description |
|---|---|
| access\_token | The access token is passed directly in the endpoint URL as a query string. For example: `?access_token=4796E23054E64BC773CACBCAF24AD179DE9A3` |

#### Cookie

| Cookie | Description |
|---|---|
| access\_token | The access token is passed in a cookie named `access_token`. For example: `Cookie: access_token=4796E23054E64BC773CACBCAF24AD179DE9A3` |

### Request Parameters

| Name | Type | Value | Optional |
|---|---|---|---|
| returnFormat | String | A string that specifies the format of the created document. Possible values are: "PDF", "PDFA", "RTF", "DOC", "DOCX", "HTML", "TX" and "TXT" (plain text). **Default value is "PDF".** | yes |

### Request Payload

| Type | Value |
|---|---|
| AppendBody | The AppendBody object contains the documents encoded as Base64 strings and a DocumentSettings object. |

#### AppendBody

| Name | Type | Value | Optional |
|---|---|---|---|
| documents | AppendDocument\[\] | The documents that are appended including divider options. | no |
| documentSettings | DocumentSettings | Document settings to specify document properties such as title and author. | yes |

#### AppendDocument

| Name | Type | Value | Optional |
|---|---|---|---|
| document | String | The document as a Base64 encoded string. | no |
| documentDivider | Integer | The document divider option. Possible values: 1 (None), 2 (NewParagraph), 3 (NewSection). Pass the number; a name such as "NewSection" is refused with 400. | yes |

#### DocumentSettings

| Name | Type | Value | Optional |
|---|---|---|---|
| author | String | Sets the document's author. | yes |
| creationDate | DateTime (String) | Sets the document's creation date which will be saved in the document. | yes |
| lastModificationDate | DateTime (String) | Sets the date the document is last modified. | yes |
| creatorApplication | String | Sets the application, which has created the document. | yes |
| documentSubject | String | Sets the document's subject string which will be saved in the document. PDF limitation: The length is limited to 2000 characters. | yes |
| documentTitle | String | Sets the document's title that will be saved in the document. PDF limitation: The length is limited to 2000 characters. | yes |
| userPassword | String | Specifies the password for the user to open the document. | yes |

### Success Response

| Status | Description |
|---|---|
| 200 | On success, the HTTP status code in the response header is 200 (OK). The response body contains the resulting document encoded as a Base64 encoded string. |

### Error Response

| Status | Description |
|---|---|
| 401 | A 401 (Unauthorized) with an empty body is returned, if OAuth is enabled and the request has no valid access token. |
| 400 | A 400 (Bad Request) is returned, if the body can't be read as an AppendBody object. The body is a problem details object (`application/json`) with the title "One or more validation errors occurred." and the message per field in `errors`. This check comes before the license check. |
| 415 | A 415 (Unsupported Media Type) is returned, if the `Content-Type` header of a request with a body is not `application/json`. |
| 405 | A 405 (Method Not Allowed) with an empty body and the header `Allow: POST` is returned for any other HTTP method, for example `GET`. |
| 400 | A 400 (Bad Request) is returned, if DS Server is not licensed or the license is invalid. On a server that is not registered, the body is the JSON string `"DS Server is not registered."` (`application/json`). DS Server checks the license before the parameter values, but after it has read the body and the typed query parameters. |
| 400 | A 400 (Bad Request) is returned, if no data is found in the AppendBody object. |
| 400 | A 400 (Bad Request) is returned, if no documents were found in the AppendBody object. |
| 400 | A 400 (Bad Request) is returned, if the uploaded document is not valid. |

---

## Nearby

- **Previous:** [/documentprocessing/document/append](https://docs.textcontrol.com/ds-server/reference/web-api/documentprocessing/document-append/llms-full.txt)
- **Next:** [/documentprocessing/document/thumbnails](https://docs.textcontrol.com/ds-server/reference/web-api/documentprocessing/document-thumbnails/llms-full.txt)
